## seqan 1.2

=== apps/Makefile ===
SEQAN_BASE = ..

# Link against runtime library on Linux systems
OS_NAME=$(shell uname)
ifeq ($(OS_NAME),Linux)
  LDFLAGS += -lrt
endif

tbb_root?=../extra/tbb

#check, if tbb_root is not absolute path (the filter keeps only /* paths)
ifeq ($(filter /% $(SLASH)%, $(subst :, ,$(tbb_root)) ),)
    # also changes related variables like work_dir
    override tbb_root := $(CWD)$(SLASH)..
    export TBB21_INSTALL_DIR := $(tbb_root)
endif

# explicitly compile for a 32 or 64 bit platform
#CXXFLAGS += -m32
#CXXFLAGS += -m64

CXXFLAGS += -I$(SEQAN_BASE)
CXXFLAGS += -O9
#CXXFLAGS += -O0 -g
CXXFLAGS += -pedantic -W -Wall
CXXFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 ${CXXEXTRAFLAGS}

# Intel Threading Building Blocks
#CXXFLAGS += -I$(SEQAN_BASE)/extra/tbb/include/
#LDFLAGS += -L$(SEQAN_BASE)/extra/tbb/build/macos_em64t_gcc_cc4.0.1_os10.5.5_debug/ -ltbb_debug -lpthread

TARGETS = dfi/dfi seqan_tcoffee/seqan_tcoffee seqcons/seqcons razers/paramChooser razers/razers pair_align/pair_align micro_razers/micro_razers tree_recon/tree_recon

all:           check_seqan_base $(TARGETS)
dfi:           check_seqan_base dfi/dfi 
razers:        check_seqan_base razers/razers razers/paramChooser
micro_razers:  check_seqan_base micro_razers/micro_razers
seqan_tcoffee: check_seqan_base seqan_tcoffee/seqan_tcoffee 
seqcons:       check_seqan_base seqcons/seqcons
pair_align:    check_seqan_base pair_align/pair_align
tree_recon:    check_seqan_base tree_recon/tree_recon

check_seqan_base:
	@if [ ! -d "$(SEQAN_BASE)/seqan" ]; then \
		echo "The directory $(SEQAN_BASE)/seqan could not be found!"; \
		exit 1; \
	fi

clean:
	rm -f $(TARGETS) $(TARGETS:=.o)

=== cmake/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6) 
project (Seqan_All CXX)

set (CMAKE_BUILD_TYPE Debug)
#set (CMAKE_BUILD_TYPE Release)

add_subdirectory (apps)
add_subdirectory (demos)
add_subdirectory (tests)

=== demos/Makefile ===
SEQAN = ..

# Link against runtime library on Linux systems
OS_NAME=$(shell uname)
ifeq ($(OS_NAME),Linux)
  LDFLAGS += -lrt
endif

CPPFLAGS += -I$(SEQAN)
CPPFLAGS += -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
CPPFLAGS += -O3
CPPFLAGS += -pedantic

all: $(basename $(wildcard *.cpp))
index: $(basename $(wildcard index_*.cpp))
graph: $(basename $(wildcard graph_*.cpp))
modifier: $(basename $(wildcard modifier_*.cpp))
file: $(basename $(wildcard file_*.cpp))
find: $(basename $(wildcard find_*.cpp))
clean:
	rm -f $(basename $(wildcard *.cpp))

=== cmake/apps/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6) 
project (Seqan_Apps CXX)

set (CMAKE_BUILD_TYPE Debug)
#set (CMAKE_BUILD_TYPE Release)

add_subdirectory (../seqan seqan)

################################################################################
# Set path variables
################################################################################

include_directories (${SEQAN_BASE})
link_directories (${SEQAN_BASE}/lib)
if (MSVC)
        add_definitions (/W2 /wd4996 /D "_CRT_SECURE_NO_WARNINGS")
endif (MSVC)

################################################################################
# Applications
################################################################################

# Find application header files
file (GLOB RAZERS_HEADERS ${SEQAN_BASE}/apps/razers/[A-z]*.h)
file (GLOB SEQAN_TCOFFEE_HEADERS ${SEQAN_BASE}/apps/seqan_tcoffee/[A-z]*.h)
list (SORT RAZERS_HEADERS)
list (SORT SEQAN_TCOFFEE_HEADERS)

# Make sure the compiler can find object files from the TBB library. 
link_directories (${SEQAN_BASE}/lib)

add_executable (dfi ${SEQAN_BASE}/apps/dfi/dfi.cpp)
add_executable (paramChooser ${SEQAN_BASE}/apps/razers/paramChooser.cpp ${RAZERS_HEADERS})
add_executable (razers ${SEQAN_BASE}/apps/razers/razers.cpp ${RAZERS_HEADERS})
add_executable (seqan_tcoffee ${SEQAN_BASE}/apps/seqan_tcoffee/seqan_tcoffee.cpp ${SEQAN_TCOFFEE_HEADERS})
add_executable (seqcons ${SEQAN_BASE}/apps/seqcons/seqcons.cpp)
add_executable (pair_align ${SEQAN_BASE}/apps/pair_align/pair_align.cpp)
add_executable (tree_recon ${SEQAN_BASE}/apps/tree_recon/tree_recon.cpp)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
	target_link_libraries (razers rt)
	target_link_libraries (paramChooser rt)
	target_link_libraries (seqan_tcoffee rt)
	target_link_libraries (seqcons rt)
	#target_link_libraries (razers tbb_debug pthread)
	#target_link_libraries (razers tbb_debug)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

=== cmake/demos/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6) 
project (Seqan_Demos CXX)

set (CMAKE_BUILD_TYPE Debug)
#set (CMAKE_BUILD_TYPE Release)

add_subdirectory (../seqan seqan)

################################################################################
# Set path variables
################################################################################

include_directories (${SEQAN_BASE})
link_directories (${SEQAN_BASE}/lib)
if (MSVC)
	add_definitions (/W2 /wd4996 /D "_CRT_SECURE_NO_WARNINGS")
endif (MSVC)

################################################################################
# Demos
################################################################################

file(GLOB SEQAN_DEMOS ${SEQAN_BASE}/demos/[A-z]*.cpp)
foreach (DEMOFILE ${SEQAN_DEMOS})
	get_filename_component (DEMO ${DEMOFILE} NAME_WE)
	add_executable (${DEMO} ${DEMOFILE})
	if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
		target_link_libraries (${DEMO} rt)
	endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
endforeach (DEMOFILE)

=== cmake/seqan/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6) 
project (Seqan CXX)

#set_property (GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS TRUE)

################################################################################
# Set path variables
################################################################################

if (NOT SEQAN_BASE)
	set (SEQAN_BASE ../.. PARENT_SCOPE)
endif (NOT SEQAN_BASE)

set (SEQAN_TARGET "SEQAN")
#set_property (GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS TRUE)

################################################################################
# Library sources
################################################################################

#if (NOT TARGET ${SEQAN_TARGET})
#get_property(IS_DEFINED GLOBAL PROPERTY SEQAN_TARGET_DEFINED)
#if (NOT ${IS_DEFINED})
#	set_property(GLOBAL PROPERTY SEQAN_TARGET_DEFINED TRUE)
	
	# Find all library headers
	get_filename_component (SEQAN_BASE_ABS ${SEQAN_BASE}/seqan ABSOLUTE)
	file (GLOB SEQAN_HEADERS ${SEQAN_BASE_ABS}/[A-z]*/[A-z]*.h)
	list (SORT SEQAN_HEADERS)
#	add_custom_target (${SEQAN_TARGET} SOURCES ${SEQAN_HEADERS})
	
	# Group library headers into modules
	foreach (SEQAN_HEADER ${SEQAN_HEADERS})
		file (RELATIVE_PATH SEQAN_HEADER_REL ${SEQAN_BASE_ABS} ${SEQAN_HEADER})
		get_filename_component (SEQAN_MODULE ${SEQAN_HEADER_REL} PATH)
		source_group (${SEQAN_MODULE} FILES ${SEQAN_HEADER})
	endforeach (SEQAN_HEADER)

#endif (NOT TARGET ${SEQAN_TARGET})
#endif (NOT ${IS_DEFINED})

################################################################################
# Set compiler flags
################################################################################

# Make sure the compiler can find include files from the SeqAn library. 
include_directories (${SEQAN_BASE})

if (CMAKE_COMPILER_IS_GNUCXX)
	set (CMAKE_CXX_WARNING_LEVEL 4 PARENT_SCOPE)
endif (CMAKE_COMPILER_IS_GNUCXX)

if (MSVC)
	add_definitions (/W2 /wd4996 /D "_CRT_SECURE_NO_WARNINGS")
endif (MSVC)

=== cmake/tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6) 
project (Seqan_Tests CXX)

set (CMAKE_BUILD_TYPE Debug)
#set (CMAKE_BUILD_TYPE Release)

add_subdirectory (../seqan seqan)

################################################################################
# Set path variables
################################################################################

include_directories (${SEQAN_BASE})
link_directories (${SEQAN_BASE}/lib)
if (MSVC)
        add_definitions (/W2 /wd4996 /D "_CRT_SECURE_NO_WARNINGS")
endif (MSVC)

################################################################################
# Tests
################################################################################

get_filename_component (SEQAN_TESTS_ABS ${SEQAN_BASE}/../tests ABSOLUTE)
#if (EXISTS SEQAN_TESTS_ABS)
	file(GLOB SEQAN_TESTS ${SEQAN_TESTS_ABS}/[A-z]*)
	foreach (TEST_DIR ${SEQAN_TESTS})
		file (RELATIVE_PATH TEST_DIR_REL ${SEQAN_TESTS_ABS} ${TEST_DIR})
		file (GLOB TEST_SOURCES ${TEST_DIR}/[A-z]*.h ${TEST_DIR}/[A-z]*.cpp)
		list (SORT TEST_SOURCES)
		if (TEST_SOURCES)
			add_executable (test_${TEST_DIR_REL} ${TEST_SOURCES})
			if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
				target_link_libraries (${test_${TEST_DIR_REL}} rt)
			endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
		endif (TEST_SOURCES)
	endforeach (TEST_DIR)
#endif (EXISTS SEQAN_TESTS_ABS)

## seqan 1.3

=== cmake/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan)

################################################################################
# Load Package Finder Modules
################################################################################

# Add FindTBB directory to CMake's module path
set(CMAKE_MODULE_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/CMake/FindTBB/"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMake/cuda"
    "${CMAKE_CURRENT_SOURCE_DIR}/CMake/"
    ${CMAKE_MODULE_PATH})
find_package (PythonInterp)

# Hacky conditional inclusion of samtools.
find_package(ZLIB QUIET)
if (ZLIB_FOUND)
  set(SAMTOOLS_FOUND "1")
  set(SAMTOOLS_CXX_FLAGS "-DSEQAN_HAS_SAMTOOLS=1")
  set(SAMTOOLS_LIBRARIES "bam")
  include_directories(${ZLIB_INCLUDE_DIRS})
else (ZLIB_FOUND)
  message("WARNING: zlib not found!")
  set(SAMTOOLS_FOUND "0")
endif (ZLIB_FOUND)

include_directories(${CMAKE_INCLUDE_PATH})

################################################################################
# Set Path Variables
################################################################################

# Set SEQAN_LIBRARY if it has not been set yet (e.g. by using ccmake).
if (NOT SEQAN_LIBRARY)
  get_filename_component (SEQAN_LIBRARY_ABS .. ABSOLUTE)
  set (SEQAN_LIBRARY ${SEQAN_LIBRARY_ABS} CACHE PATH
       "Path to SeqAn's parent folder (contains apps,demos,seqan)")
endif (NOT SEQAN_LIBRARY)

# Path to and not including the "projects" directory.
get_filename_component (SEQAN_SOURCE_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/../../.. ABSOLUTE)
get_filename_component (SEQAN_BINARY_ROOT ${CMAKE_CURRENT_BINARY_DIR}/../../.. ABSOLUTE)

set (SEQAN_TARGET "Seqan")

################################################################################
# Include paths for vendor copies of libraries.
################################################################################

INCLUDE_DIRECTORIES(${SEQAN_LIBRARY}/lib/samtools)

################################################################################
# Define SeqAn Library Related Variables
#
# We define some variables that contain the base path of the library,
# a list of all headers in SeqAn, the modules and generated forwards.
################################################################################

# Absolute path to "seqan" directory goes into SEQAN_BASE_ABS.
get_filename_component (SEQAN_BASE_ABS ${SEQAN_LIBRARY}/seqan ABSOLUTE)

# A sorted list of all SeqAn headers goes into SEQAN_HEADERS.  We
# exclude the generated headers.
file (GLOB SEQAN_HEADERS_TMP ${SEQAN_BASE_ABS}/[A-z]*/[A-z]*.h)
file (GLOB SEQAN_SUPER_HEADERS ${SEQAN_BASE_ABS}/[A-z]*.h)
foreach (HEADER ${SEQAN_HEADERS_TMP})
  if (NOT ${HEADER} MATCHES ".*generated.*")
    list (APPEND SEQAN_HEADERS ${HEADER})
  endif (NOT ${HEADER} MATCHES ".*generated.*")
endforeach (HEADER ${SEQAN_HEADERS})
list (SORT SEQAN_HEADERS)

# A sorted list of all SeqAn modules goes into SEQAN_MODULES.
file (GLOB SEQAN_BASE_CONTENTS
      RELATIVE ${SEQAN_BASE_ABS}
      ${SEQAN_BASE_ABS}/[A-z]*)
foreach (ENTRY ${SEQAN_BASE_CONTENTS})
  if (IS_DIRECTORY ${SEQAN_BASE_ABS}/${ENTRY})
    list (APPEND SEQAN_MODULES ${ENTRY})
  endif (IS_DIRECTORY ${SEQAN_BASE_ABS}/${ENTRY})
endforeach (ENTRY ${SEQAN_BASE_CONTENTS})
list (SORT SEQAN_MODULES)
list (REMOVE_DUPLICATES SEQAN_MODULES)

################################################################################
# CMake Bug Workarounds
################################################################################

# For Non-GUI generators there is a bug in cmake: The SOURCE command in
# add_custom_target is not recognized there
set (NONGUI_GENERATORS "Unix Makefiles" "MinGW Makefiles")
list (FIND NONGUI_GENERATORS ${CMAKE_GENERATOR} FOUND)
if (FOUND EQUAL -1)
  set (SEQAN_GUI_SOURCES SOURCES ${SEQAN_HEADERS} ${SEQAN_SUPER_HEADERS})
endif (FOUND EQUAL -1)

################################################################################
# Forwards Generation For g++ Version >= 4.0
################################################################################

if (CMAKE_COMPILER_IS_GNUCXX)
  # Build a list of generated forwards headers.  Goes into SEQAN_FORWARDS.
  foreach (MODULE ${SEQAN_MODULES})
    list (APPEND SEQAN_FORWARDS
          ${SEQAN_BASE_ABS}/${MODULE}/${MODULE}_generated_forwards.h)
  endforeach (MODULE ${SEQAN_MODULES})

  # Now tell CMake that the forward headers can be generated with
  # build_forwards.py
  add_custom_command (
    OUTPUT ${SEQAN_FORWARDS}
    COMMAND ${PYTHON_EXECUTABLE} ${SEQAN_LIBRARY}/../../misc/build_forwards.py
            ${SEQAN_BASE_ABS} all
    DEPENDS ${SEQAN_HEADERS})
endif (CMAKE_COMPILER_IS_GNUCXX)

################################################################################
# SeqAn Pseudo Target
#
# We create a target ${SEQAN_TARGET} that contains all SeqAn headers,
# sources and the generated forwards.
################################################################################

# Note that SEQAN_FORWARDS is not defined when not compiling with g++
# which implies no forwards generation for non-g++ compilers.
add_custom_target (${SEQAN_TARGET}
  DEPENDS ${SEQAN_HEADERS}
          ${SEQAN_FORWARDS}
          ${SEQAN_GUI_SOURCES}
)

# Group library headers into modules.
foreach (SEQAN_HEADER ${SEQAN_HEADERS})
  file (RELATIVE_PATH SEQAN_HEADER_REL ${SEQAN_BASE_ABS} ${SEQAN_HEADER})
  get_filename_component (SEQAN_MODULE ${SEQAN_HEADER_REL} PATH)
  source_group (${SEQAN_MODULE} FILES ${SEQAN_HEADER})
endforeach (SEQAN_HEADER)

################################################################################
# Set Compiler Flags
################################################################################

# Make sure the compiler can find include files from the SeqAn library.
include_directories (${SEQAN_LIBRARY})

# We enable maximal warnings for the GCC.
if (CMAKE_COMPILER_IS_GNUCXX)
  # For the GCC, enable warnings.
  set (CMAKE_CXX_WARNING_LEVEL 4)
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall -Wno-long-long")

  # Determine GCC version.
  message("Determining GCC version.")
  EXEC_PROGRAM(${CMAKE_CXX_COMPILER}
               ARGS --version
               OUTPUT_VARIABLE _GCC_VERSION)
  STRING(REGEX REPLACE ".* ([0-9])\\.([0-9])\\.([0-9]) .*" "\\1\\2\\3"
         _GCC_VERSION ${_GCC_VERSION})
  message("  GCC version is ${_GCC_VERSION}")

  # Add -Wno-longlong if the GCC version is < 4.0.0.  Add -pedantic flag
  # but disable warnings for variadic macros with GCC >= 4.0.0.  Earlier
  # versions warn because of anonymous variadic macros in pedantic mode
  # but do not have a flag to disable these warnings.
  if (400 GREATER _GCC_VERSION)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
  else (400 GREATER _GCC_VERSION)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -Wno-variadic-macros")
  endif (400 GREATER _GCC_VERSION)

  # Force GCC to keep the frame pointer when debugging is enabled.
  # This is mainly important for 64 bit but does not get into the way
  # on 32 bit either at minimal performance impact.
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer")
  set(CMAKE_CXX_FLAGS_RELDEBUG "${CMAKE_CXX_FLAGS_RELEASE} -g")# -fno-omit-frame-pointer")
  
  # Pass CXX flags to flags.
  #set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DSEQAN_CXX_FLAGS_=\"${CMAKE_CXX_FLAGS}\"")
endif (CMAKE_COMPILER_IS_GNUCXX)

if (MSVC)
  # Warning level 3 for MSVC is disabled for now to see how much really bad warnings there are.
  #set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3  /wd4996 -D_CRT_SECURE_NO_WARNINGS")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W2  /wd4996 -D_CRT_SECURE_NO_WARNINGS")
  # Disable Microsoft C++ language extensions.
  # TODO(holtgrew): Re-disable again, Microsoft's header do not compile with this option! Look for a workaround.
  #set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Za")
endif (MSVC)

################################################################################
# Set Default Build Type
################################################################################

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE Debug CACHE STRING
      "Choose the type of build, options are: Debug Release."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

################################################################################
# Define Convenience Macros
################################################################################

macro(SEQAN_ADD_EXECUTABLE seqan_target)

	# create a new target
	add_executable(${seqan_target} ${ARGN})

	# add dependency to SeqAn library
	add_dependencies (${seqan_target} ${SEQAN_TARGET})

	# optionally link against runtime-library
	if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
		target_link_libraries (${seqan_target} rt)
	endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

endmacro(SEQAN_ADD_EXECUTABLE seqan_target)

################################################################################
# Include Sub-Projects
################################################################################

add_subdirectory (libs)
add_subdirectory (apps)
add_subdirectory (demos)
add_subdirectory (tests)
add_subdirectory (benchmarks)

=== cmake/apps/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan_Apps)

################################################################################
# For the apps, use assertions in debug mode, no assertions in
# release mode and never go into testing mode.
################################################################################

# Use CMake's package location functionality to find the directories of
# TBB and Boost.
find_package (TBB QUIET)
find_package (CUDA)
find_package (OpenMP QUIET)
find_package (Boost 1.35.0)  # >= 1.35 for math/distributions, however broken?
find_package (TR1)

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ${SAMTOOLS_CXX_FLAGS} -DSEQAN_ENABLE_TESTING=0")
set (CMAKE_CXX_FLAGS_RELDEBUG "${CMAKE_CXX_FLAGS_RELDEBUG} -DSEQAN_ENABLE_DEBUG=0")
set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DSEQAN_ENABLE_DEBUG=0")
set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DSEQAN_ENABLE_DEBUG=1")

# We need Boost >= 1.35.0.  However, the FindBoost module seems to be
# broken in this respect, so we will set Boost_FOUND to FALSE if the version
# is not large enough on our own.
if (Boost_FOUND)
  if (Boost_VERSION LESS 103500 )
    set (Boost_FOUND FALSE)
  endif (Boost_VERSION LESS 103500 )
endif (Boost_FOUND)

################################################################################
# Set CUDA variables
################################################################################

set (CUDA_PROPAGATE_HOST_FLAGS OFF)
set (CUDA_ATTACH_VS_BUILD_RULE_TO_CUDA_FILE OFF)
#set (CUDA_NVCC_FLAGS "-pg")
list (APPEND CMAKE_CXX_SOURCE_FILE_EXTENSIONS "cu")
cuda_include_directories(${CUDA_CUT_INCLUDE_DIR})
#string (REGEX REPLACE "\\-(W( |all)|pedantic)" "" CUDA_CXX_FLAGS ${CUDA_NVCC_FLAGS} ${CMAKE_CXX_FLAGS})
string (REGEX REPLACE "\\-pedantic" "" CUDA_CXX_FLAGS ${CUDA_NVCC_FLAGS} ${CMAKE_CXX_FLAGS})

################################################################################
# Set path variables
################################################################################

# If Boost is not found then Boost_INCLUDE_DIRS will be set
# to "NOTFOUND" which will make CMake complain on Windows.
if (Boost_FOUND)
  set (BOOST_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
endif (Boost_FOUND)

# Make sure the compiler can find include files from the SeqAn, Boost and TBB library.
include_directories (${SEQAN_LIBRARY}
                     ${TBB_INCLUDE_DIRS}
                     ${BOOST_INCLUDE_DIRS})
link_directories (${SEQAN_LIBRARY}/lib
                  ${TBB_LIBRARY_DIRS})

# Make sure the compiler can find object files from the TBB library.
##link_directories (${SEQAN_LIBRARY}/lib)
# ^-- currently not working because cmake appends Debug|Release to ../lib/

################################################################################
# Applications
################################################################################

# TODO(holtgrew): Disable apps if dependencies are missing.  This would mean removing the automatic generation of targets but this invites errors anyway.

# pseudo-target to build all apps
add_custom_target (apps)

# Find targets automatically
get_filename_component (SEQAN_APPS_ABS ${SEQAN_LIBRARY}/apps ABSOLUTE)
file (GLOB SEQAN_APPS ${SEQAN_APPS_ABS}/[A-z]*)

file (GLOB INSEGT_HEADERS ${SEQAN_LIBRARY}/apps/insegt/[A-z]*.h)
file (GLOB RAZERS_HEADERS ${SEQAN_LIBRARY}/apps/razers/[A-z]*.h)
file (GLOB RAZERS2_HEADERS ${SEQAN_LIBRARY}/apps/razers2/[A-z]*.h)
file (GLOB RAZERS3_HEADERS ${SEQAN_LIBRARY}/apps/razers3/[A-z]*.h)
file (GLOB SEQAN_TCOFFEE_HEADERS ${SEQAN_LIBRARY}/apps/seqan_tcoffee/[A-z]*.h)

# Manually add predefined targets
list (APPEND SEQAN_APPS ${SEQAN_LIBRARY}/apps/paramChooser)
list (APPEND SEQAN_APPS ${SEQAN_LIBRARY}/apps/transrectify)
list (APPEND SEQAN_APPS ${SEQAN_LIBRARY}/apps/transsplice)
list (APPEND SEQAN_APPS ${SEQAN_LIBRARY}/apps/chopsuey)
set  (APP_transrectify_SOURCES ${SEQAN_LIBRARY}/apps/transquant/transrectify.cpp)
set  (APP_transsplice_SOURCES ${SEQAN_LIBRARY}/apps/transquant/transsplice.cpp)
set  (APP_chopsuey_SOURCES ${SEQAN_LIBRARY}/apps/transquant/chopsuey.cpp)

# Manually set predefined sets of source files for some targets
set (APP_razers_SOURCES ${SEQAN_LIBRARY}/apps/razers/razers.cpp ${RAZERS_HEADERS})
set (APP_razers2_SOURCES ${SEQAN_LIBRARY}/apps/razers2/razers.cpp ${RAZERS2_HEADERS})
set (APP_micro_razers_SOURCES ${SEQAN_LIBRARY}/apps/micro_razers/micro_razers.cpp ${RAZERS_HEADERS})
set (APP_paramChooser_SOURCES ${SEQAN_LIBRARY}/apps/razers/paramChooser.cpp ${RAZERS_HEADERS})
set (APP_insegt_SOURCES ${SEQAN_LIBRARY}/apps/insegt/insegt.cpp ${INSEGT_HEADERS})
if (Boost_FOUND)
  set (APP_transquant_SOURCES ${SEQAN_LIBRARY}/apps/transquant/transquant.cpp)
else (Boost_FOUND)
  message ("WARNING Boost not found, not building transquant!")
  # Disable building of transquant.
  set (APP_transquant_NOBUILD TRUE)
  list (REMOVE_ITEM SEQAN_APPS ${SEQAN_LIBRARY}/apps/transquant)
endif (Boost_FOUND)
if (OpenMP_CXX_FLAGS)
  if (Boost_FOUND OR TR1_SHARED_PTR_FOUND)
    if (NOT MINGW)
      set (APP_razers3_SOURCES ${SEQAN_LIBRARY}/apps/razers3/razers.cpp ${RAZERS3_HEADERS})
    else (NOT MINGW)
      message ("RazerS 3 is not built on MinGW since __sync_val_compare_and_swap is missing.")
      set (APP_razers3_NOBUILD true)
      list (REMOVE_ITEM SEQAN_APPS ${SEQAN_LIBRARY}/apps/razers3)
    endif (NOT MINGW)
  else (Boost_FOUND OR TR1_SHARED_PTR_FOUND)
    # TODO(holtgrew): Is there a better way to specify complex dependencies?
    message ("WARNING neither TR1 nor Boost found, not building razers3!")
    # Disable building of RazerS 3.
    set (APP_razers3_NOBUILD true)
    list (REMOVE_ITEM SEQAN_APPS ${SEQAN_LIBRARY}/apps/razers3)
  endif (Boost_FOUND OR TR1_SHARED_PTR_FOUND)
else (OpenMP_CXX_FLAGS)
  message ("WARNING OpenMP not found, not building razers3!")
  # Disable building of RazerS 3.
  set (APP_razers3_NOBUILD true)
  list (REMOVE_ITEM SEQAN_APPS ${SEQAN_LIBRARY}/apps/razers3)
endif (OpenMP_CXX_FLAGS)

################################################################################
# Auto-generate headers.
################################################################################

foreach (APP_DIR ${SEQAN_APPS})
  if (EXISTS ${APP_DIR}/config.h.in)
    configure_file (${APP_DIR}/config.h.in
                    ${APP_DIR}/config.h)
  endif (EXISTS ${APP_DIR}/config.h.in)
endforeach (APP_DIR ${SEQAN_APPS})

################################################################################
# Build applications.
################################################################################

# Make sure the compiler can find object files from the TBB library.
link_directories (${SEQAN_LIBRARY}/lib)

foreach (APP_DIR ${SEQAN_APPS})
	file (RELATIVE_PATH APP_DIR_REL ${SEQAN_APPS_ABS} ${APP_DIR})

	# if there is no predefined set of files for this target
	# find the source files automatically
	if (NOT APP_${APP_DIR_REL}_SOURCES)
		file (GLOB APP_${APP_DIR_REL}_SOURCES ${APP_DIR}/[A-z]*.cpp ${APP_DIR}/[A-z]*.h ${APP_DIR}/[A-z]*.cu)
	endif (NOT APP_${APP_DIR_REL}_SOURCES)

	foreach (SRC ${APP_${APP_DIR_REL}_SOURCES})
		if (NOT EXISTS ${SRC})
#			message ("WARNING ${SRC} not found. Disabling ${APP_DIR_REL}.")
			set (APP_${APP_DIR_REL}_NOBUILD TRUE)
		endif (NOT EXISTS ${SRC})
	endforeach (SRC)

	# auto-detect CUDA targets
	foreach (SRC ${APP_${APP_DIR_REL}_SOURCES})
		get_filename_component(SRC_EXT ${SRC} EXT)
		if (${SRC_EXT} STREQUAL ".cu")
#			message ("Found CUDA target: ${APP_DIR_REL}")
			set (APP_${APP_DIR_REL}_CUDA TRUE)
			if (NOT CUDA_FOUND)
				set (APP_${APP_DIR_REL}_NOBUILD TRUE)
			endif (NOT CUDA_FOUND)
		endif (${SRC_EXT} STREQUAL ".cu")
	endforeach (SRC)

	# add target, dependencies and linked libraries
	set (SAVED_FLAGS ${CMAKE_CXX_FLAGS})
	if (APP_${APP_DIR_REL}_SOURCES)
		if (APP_${APP_DIR_REL}_NOBUILD)
			message ("Not building ${APP_DIR_REL} -- it is deactivated.")
		else (APP_${APP_DIR_REL}_NOBUILD)
			list (SORT APP_${APP_DIR_REL}_SOURCES)
			if (APP_${APP_DIR_REL}_CUDA)
			  message ("Found CUDA target: ${APP_DIR_REL}")
			  set (CMAKE_CXX_FLAGS ${CUDA_CXX_FLAGS})
			  cuda_add_executable(${APP_DIR_REL} ${APP_${APP_DIR_REL}_SOURCES})
			  target_link_libraries(${APP_DIR_REL} ${CUDA_CUT_LIBRARY})
			else (APP_${APP_DIR_REL}_CUDA)
			  add_executable (${APP_DIR_REL} ${APP_${APP_DIR_REL}_SOURCES})
			endif (APP_${APP_DIR_REL}_CUDA)
			add_dependencies (${APP_DIR_REL} ${SEQAN_TARGET})
			add_dependencies (apps ${APP_DIR_REL})
            # Link against libz everywhere, used for reading BAM, for example.
            if (ZLIB_FOUND)
			  target_link_libraries (${APP_DIR_REL} z)
            endif (ZLIB_FOUND)
            # Link against librt on Linux for real-time clock.
			if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
				target_link_libraries (${APP_DIR_REL} rt)
			endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
			set (CMAKE_CXX_FLAGS ${SAVED_FLAGS})
		endif (APP_${APP_DIR_REL}_NOBUILD)
	endif (APP_${APP_DIR_REL}_SOURCES)
endforeach (APP_DIR)

=== cmake/benchmarks/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

################################################################################
# For the benchmark apps, use assertions in debug mode, no assertions in
# release mode and never go into testing mode.
################################################################################

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -DSEQAN_ENABLE_TESTING=0")
set (CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DSEQAN_ENABLE_DEBUG=0")
set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DSEQAN_ENABLE_DEBUG=1")

################################################################################
# Include the CMakeLists.txt for each benchmark's app directory.
################################################################################

get_filename_component (SEQAN_BENCHMARK_ABS ${SEQAN_LIBRARY}/../benchmarks ABSOLUTE)
file (GLOB SEQAN_BENCHMARKS ${SEQAN_BENCHMARK_ABS}/[A-z]*)

foreach (BENCHMARK_DIR ${SEQAN_BENCHMARKS})
  get_filename_component(BENCHMARK_NAME ${BENCHMARK_DIR} NAME)
  if (EXISTS ${BENCHMARK_DIR}/apps/CMakeLists.txt)
    add_subdirectory(${BENCHMARK_DIR}/apps ${BENCHMARK_NAME})
  endif (EXISTS ${BENCHMARK_DIR}/apps/CMakeLists.txt)
endforeach (BENCHMARK_DIR ${SEQAN_BENCHMARK})

=== cmake/tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (Seqan_Tests)

# Some tests need OpenMP.
find_package (OpenMP QUIET)

################################################################################
# For the tests, we switch SeqAn into testing mode.
################################################################################

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ${SAMTOOLS_CXX_FLAGS} -DSEQAN_ENABLE_DEBUG=1 -DSEQAN_ENABLE_TESTING=1")
# Also enable flags for coverage analysis.
if (MODEL STREQUAL "NightlyCoverage")
  if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set (LDFLAGS "${LDFLAGS} -fprofile-arcs -ftest-coverage")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif (MODEL STREQUAL "NightlyCoverage")
if (MODEL STREQUAL "ExperimentalCoverage")
  if (CMAKE_COMPILER_IS_GNUCXX)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")
    set (LDFLAGS "${LDFLAGS} -fprofile-arcs -ftest-coverage")
  endif (CMAKE_COMPILER_IS_GNUCXX)
endif (MODEL STREQUAL "ExperimentalCoverage")

################################################################################
# Set path variables
################################################################################

include_directories (${SEQAN_LIBRARY})
link_directories (${SEQAN_LIBRARY}/lib)

################################################################################
# Define which tests are to link against libbam.
################################################################################

MACRO(LIST_CONTAINS var value)
  SET(${var})
  FOREACH (value2 ${ARGN})
    IF (${value} STREQUAL ${value2})
      SET(${var} TRUE)
    ENDIF (${value} STREQUAL ${value2})
  ENDFOREACH (value2)
ENDMACRO(LIST_CONTAINS)

set(SEQAN_LINK_LIBBAM ${SEQAN_LINK_LIBBAM} test_store)

################################################################################
# Tests
################################################################################

add_custom_target(tests)

#-----------------------------------------------------------------------------
# Configure Dart testing support.  This should be done before any
# MESSAGE(FATAL_ERROR ...) commands are invoked.
INCLUDE(CTest)
ENABLE_TESTING()
IF(BUILD_TESTING)
  SET(BUILDNAME "${BUILDNAME}" CACHE STRING "Name of build on the dashboard")
  MARK_AS_ADVANCED(BUILDNAME)
ENDIF(BUILD_TESTING)

get_filename_component (SEQAN_TESTS_ABS ${SEQAN_LIBRARY}/../tests ABSOLUTE)
#if (EXISTS SEQAN_TESTS_ABS)
	file(GLOB SEQAN_TESTS ${SEQAN_TESTS_ABS}/[A-z]*)
	foreach (TEST_DIR ${SEQAN_TESTS})
		file (RELATIVE_PATH TEST_DIR_REL ${SEQAN_TESTS_ABS} ${TEST_DIR})
		file (GLOB TEST_SOURCES ${TEST_DIR}/[A-z]*.h ${TEST_DIR}/test_[A-z]*.cpp)
		list (SORT TEST_SOURCES)
		if (TEST_SOURCES)
			add_executable (test_${TEST_DIR_REL} ${TEST_SOURCES})
			add_dependencies (test_${TEST_DIR_REL} ${SEQAN_TARGET})
	    add_dependencies (tests test_${TEST_DIR_REL})
        
    # Conditionally link against libbam.
    if (SAMTOOLS_FOUND)
      LIST_CONTAINS(contains test_${TEST_DIR_REL} ${SEQAN_LINK_LIBBAM})
      if (contains)
        if (ZLIB_FOUND)
          target_link_libraries(test_${TEST_DIR_REL} ${SAMTOOLS_LIBRARIES} ${ZLIB_LIBRARIES})
        else (ZLIB_FOUND)
          target_link_libraries(test_${TEST_DIR_REL} ${SAMTOOLS_LIBRARIES})
        endif (ZLIB_FOUND)
      endif (contains)
    endif (SAMTOOLS_FOUND)
    
      # Create a variable with the paths to the tests for memory checks.
      # TODO(holtgrew): For MSVC the paths are different, but does not matter as not run on Windows yet.
      if (MODEL MATCHES ".*Mem.*Check")
        set(TEST_PATH ${SEQAN_BINARY_ROOT}/projects/library/cmake/tests/)
      endif (MODEL MATCHES ".*Mem.*Check")
			add_test (test_${TEST_DIR_REL} ${TEST_PATH}test_${TEST_DIR_REL})
			if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
				target_link_libraries (test_${TEST_DIR_REL} rt)
			endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
		endif (TEST_SOURCES)
	endforeach (TEST_DIR)
#endif (EXISTS SEQAN_TESTS_ABS)

set (SEQAN_TESTS_APPS_DIR "${SEQAN_TESTS_ABS}/apps")

file(GLOB SEQAN_TESTS ${SEQAN_TESTS_APPS_DIR}/[A-z]*)
foreach (TEST_DIR ${SEQAN_TESTS})
  file (RELATIVE_PATH TEST_DIR_REL ${SEQAN_TESTS_APPS_DIR} ${TEST_DIR})
  if (MODEL MATCHES ".*Mem.*Check")
    add_test(test_apps_${TEST_DIR_REL} ${PYTHON_EXECUTABLE} ${TEST_DIR}/run_tests.py --valgrind ${SEQAN_SOURCE_ROOT} ${SEQAN_BINARY_ROOT})
  else (MODEL MATCHES ".*Mem.*Check")
    add_test(test_apps_${TEST_DIR_REL} ${PYTHON_EXECUTABLE} ${TEST_DIR}/run_tests.py ${SEQAN_SOURCE_ROOT} ${SEQAN_BINARY_ROOT})
  endif (MODEL MATCHES ".*Mem.*Check")
endforeach (TEST_DIR)

=== debian/changelog ===
seqan (1.3-1ubuntu2) precise; urgency=low

  * debian/control: Add Pre-Depends to dpkg (>= 1.15.6~) to fix upload
    problem with xz compression, thanks to micahg for pointing this.

 -- Mahyuddin Susanto <udienz@ubuntu.com>  Wed, 18 Jan 2012 23:54:16 +0700

seqan (1.3-1ubuntu1) precise; urgency=low

  * Merge from Debian testing. Remaining changes:
    - debian/patches/ls-as-needed.patch: Fix FTBFS binutils gold with ld
      --as-needed.

 -- Mahyuddin Susanto <udienz@ubuntu.com>  Wed, 18 Jan 2012 17:21:10 +0700

seqan (1.3-1) unstable; urgency=low

  * Team upload.
  * New upstream release (Closes: #640302).

  [ Charles Plessy ]
  * Collected various informations in ‘debian/upstream-metadata.yaml’.
  * Compress the source and binary packages with xz
    (debian/orig-tar.sh, debian/rules).
  * Removed convenience code copy of samtools (debian/orig-tar.sh).
  * Use Debhelper 8 (debian/compat, debian/control).
  * Conforms to Policy 3.9.2 (debian/control, no other changes needed).
  * Built using the cmake class of CDBS (debian/rules).
  * debian/control:
    - Corrected VCS URLs.
    - Build-Depend on libboost-dev as Cmake was looking for it.
    - Build-Depend on zlib1g-dev, as seqan needs to detect zlib to set
      SEQAN_HAS_SAMTOOLS to 1.
    - Changed Priority from extra to optional.
    - Changed sequan-apps Section from libdevel to science.
  * debian/patch/samtools.patch corrects path to SAMtools headers.
  * Machine-readable debian/copyright.

  [ Andreas Tille ]
  * debian/control
    - added myself to uploaders
    - Standards-Version: 3.9.1 (no changes needed)
  * debian/watch: Allso catch RC candidates
  * debian/source/format: 3.0 (quilt)

 -- Charles Plessy <plessy@debian.org>  Fri, 16 Sep 2011 12:51:39 +0900

seqan (1.2-1ubuntu2) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:20:35 -0700

seqan (1.2-1ubuntu1) oneiric; urgency=low

  * Fix FTBFS with ld --as-needed. LP: #832793.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 19 Sep 2011 23:52:47 +0000

seqan (1.2-1) unstable; urgency=low

  * Initial Release  (Closes: #487361)

 -- Soeren Sonnenburg <sonne@debian.org>  Wed, 30 Sep 2009 20:41:39 +0200

=== debian/control ===
Source: seqan
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Soeren Sonnenburg <sonne@debian.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: cdbs, debhelper (>= 8), cmake, zlib1g-dev, libbam-dev, libboost-dev
Standards-Version: 3.9.2
Homepage: http://www.seqan.de/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/seqan/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/seqan/trunk/

Package: seqan-apps
Architecture: any
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: seqan-dev
Section: libdevel
Architecture: all
Pre-Depends: dpkg (>= 1.15.6)
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the developer files, documentation
 and examples.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_SRCDIR              := cmake
DEB_MAKE_INSTALL_TARGET :=

DEB_DH_BUILDDEB_ARGS = -- -Zxz

install/seqan-apps:: debian/stamp-install-seqan-apps
debian/stamp-install-seqan-apps:
	mkdir -p $(CURDIR)/debian/seqan-apps/usr/bin
	mkdir -p $(CURDIR)/debian/seqan-apps/usr/lib/sequan/bin
	mkdir -p $(CURDIR)/debian/seqan-apps/usr/share/doc/seqan-apps
	#install binaries
	for APP in dfi insegt mason micro_razers pair_align param_chooser rabema razers razers2 read_analyzer rep_sep sak seqan_tcoffee seqcons snp_store splazers stellar tree_recon ; do \
	  cp -p $(CURDIR)/obj*/apps/$$APP $(CURDIR)/debian/seqan-apps/usr/lib/sequan/bin/ ; done
	# Links for compatibility with seqan 1.2-1
	for APP in dfi micro_razers pair_align razers seqan_tcoffee seqcons tree_recon ; do \
	  ln -s /usr/lib/sequan/bin/$$APP $(CURDIR)/debian/seqan-apps/usr/bin/$$APP ; done
	#install readmes
	for APP in dfi insegt mason micro_razers razers razers2 sak seqan_tcoffee splazers stellar ; do \
	  cp -p $(CURDIR)/apps/$$APP/README $(CURDIR)/debian/seqan-apps/usr/share/doc/seqan-apps/README.$$APP ; done
	touch $@

install/seqan-dev:: debian/stamp-install-seqan-dev
debian/stamp-install-seqan-dev:
	mkdir -p $(CURDIR)/debian/seqan-dev/usr/include
	mkdir -p $(CURDIR)/debian/seqan-dev/usr/share/doc/seqan-dev
	cp -a $(CURDIR)/seqan $(CURDIR)/debian/seqan-dev/usr/include/
	cp -a $(CURDIR)/demos $(CURDIR)/debian/seqan-dev/usr/share/doc/seqan-dev
	cp -a $(CURDIR)/doc $(CURDIR)/debian/seqan-dev/usr/share/doc/seqan-dev
	touch $@

get-orig-source:
	uscan --force-download
	@echo successfully retrieved upstream tarball

clean::
	$(RM) -r debian/stamp-*
